USE AdventureWorks
SELECT * 
INTO heap
FROM Sales.SalesOrderHeader
GO
SELECT * 
FROM sys.sysindexes
WHERE OBJECT_NAME(id)='heap'
GO
SELECT * 
FROM sys.indexes
WHERE OBJECT_NAME(object_id)='heap'
GO
DBCC IND(AdventureWorks,heap,-1)
GO
SELECT * 
FROM sys.system_internals_allocation_units
WHERE allocation_unit_id = 
GO

EXEC sp_helpindex 'Sales.SalesOrderHeader'
GO
SELECT * 
FROM Sales.SalesOrderHeader
ORDER BY SalesOrderID 

SELECT * 
FROM Sales.SalesOrderHeader
ORDER BY SalesOrderID DESC
GO
CREATE TABLE ZlyCLI(
KlientID UNIQUEIDENTIFIER PRIMARY KEY DEFAULT (NEWID()),
Imie NVARCHAR(50) DEFAULT ('Marcin'),
Nazwisko NVARCHAR(50) DEFAULT ('Szeliga'),
Miasto NVARCHAR(50) DEFAULT ('Katowice'),
Adres NVARCHAR(50)  DEFAULT ('Harcerzy Wrzesnia 1'),
Email NCHAR(50) DEFAULT (N'marcin@wss.pl'),
Data DATETIME DEFAULT (GETDATE()),
[Login] nchar(15) DEFAULT (N'marszeli'),
Numer INT )

INSERT INTO ZlyCLI (Imie,Nazwisko,Email,Data, numer)
SELECT FirstName, LastName,EmailAddress ,ModifiedDate,ContactID 
FROM AdventureWorks.Person.Contact

CREATE TABLE DobryCLI(
KlientID INT PRIMARY KEY IDENTITY (1,1) ,
Imie NVARCHAR(50) DEFAULT ('Marcin'),
Nazwisko NVARCHAR(50) DEFAULT ('Szeliga'),
Miasto NVARCHAR(50) DEFAULT ('Katowice'),
Adres NVARCHAR(50)  DEFAULT ('Harcerzy Wrzesnia 1'),
Email NCHAR(50) DEFAULT (N'marcin@wss.pl'),
Data DATETIME DEFAULT (GETDATE()),
[Login] NCHAR(15) DEFAULT (N'marszeli'),
Numer INT )

INSERT INTO DobryCLI (Imie,Nazwisko,Email,Data, numer)
SELECT FirstName, LastName,EmailAddress ,ModifiedDate, ContactID
FROM AdventureWorks.Person.Contact
GO
CREATE TABLE DodatkowaKolumnaCLI (
KlientID UNIQUEIDENTIFIER PRIMARY KEY NONCLUSTERED,
kluczCLI INT IDENTITY (1,1) CONSTRAINT cli UNIQUE CLUSTERED)
GO
CREATE NONCLUSTERED INDEX IX_heap_CustomerID 
ON dbo.heap (CustomerID)
GO

SELECT *
FROM dbo.heap
WHERE SalesOrderNumber= 'SO43663'
SELECT *
FROM Sales.SalesOrderHeader
WHERE SalesOrderNumber= 'SO43663'
GO

SELECT *
FROM Sales.SalesOrderHeader
WHERE SalesOrderID = 43661
SELECT *
FROM Sales.SalesOrderHeader
WHERE SalesOrderID < 50000
SELECT *
FROM Sales.SalesOrderHeader
WHERE SalesOrderID > 50000
GO
SELECT * 
FROM heap
WHERE CustomerID <32
GO
SELECT * 
FROM Sales.SalesOrderHeader
WHERE CustomerID <32
GO

CREATE UNIQUE INDEX nclZ1 
ON dbo.ZlyCLI([Login],Email)
WITH IGNORE_DUP_KEY
CREATE UNIQUE INDEX nclD1 
ON dbo.DobryCLI([Login],Email)
WITH IGNORE_DUP_KEY
GO
CREATE NONCLUSTERED INDEX nclZ2 
ON dbo.ZlyCLI(Numer)
CREATE NONCLUSTERED INDEX nclD2 
ON dbo.DobryCLI(Numer)
GO
CREATE INDEX nclZ3 
ON dbo.ZlyCLI(Nazwisko)
WITH FILLFACTOR = 85
CREATE INDEX nclD3 
ON dbo.DobryCLI(Nazwisko)
WITH FILLFACTOR = 85
GO
CREATE INDEX nclZ4 
ON dbo.ZlyCLI(Imie)
WITH SORT_IN_TEMPDB 
CREATE INDEX nclD4 
ON dbo.DobryCLI(Imie)
WITH SORT_IN_TEMPDB
GO
CREATE INDEX nclZ5 
ON dbo.ZlyCLI(Adres,Miasto)
CREATE INDEX nclD5 
ON dbo.DobryCLI(Adres,Miasto)
GO
CREATE INDEX nclZ6 
ON dbo.ZlyCLI(Nazwisko)
INCLUDE (Imie,Email)
CREATE INDEX nclD6 
ON dbo.DobryCLI(Nazwisko)
INCLUDE (Imie,Email)
GO

SELECT *
FROM sys.dm_exec_sessions
WHERE session_id=@@SPID
GO
SELECT COLUMNPROPERTY (OBJECT_ID('tab1'),'kol3','IsDeterministic')
GO
CREATE INDEX IX_tab1_kol3
ON tab1(kol3)
GO
EXEC sp_spaceused 'dbo.heap'
EXEC sp_spaceused 'Sales.SalesOrderHeader'
GO
SELECT index_id, used_page_count, reserved_page_count
FROM sys.dm_db_partition_stats
WHERE object_id = object_id('Sales.SalesOrderHeader')
GO

DBCC SHOW_STATISTICS (heap,IX_heap_CustomerID)
GO
ALTER INDEX UQ_tab1_kol2
ON tab1
SET (STATISTICS_NORECOMPUTE = ON)
GO
CREATE STATISTICS stats1 
ON tab1(kol3)
WITH NORECOMPUTE
GO

ALTER INDEX ALL
ON HumanResources.Department
REBUILD WITH (SORT_IN_TEMPDB =ON)
GO
ALTER INDEX IX_Employee_ManagerID
ON HumanResources.Employee
REORGANIZE
GO
ALTER INDEX UQ_tab1_kol2
ON tab1
DISABLE
GO
DROP INDEX IX_heap_CustomerID
ON heap
