USE AdventureWorks
SELECT *
FROM HumanResources.Department CROSS JOIN HumanResources.EmployeeDepartmentHistory 
GO
SELECT *
FROM HumanResources.Department D INNER JOIN HumanResources.EmployeeDepartmentHistory H
ON D.DepartmentID = H.DepartmentID
GO
INSERT INTO HumanResources.Department (Name,GroupName )
VALUES ('TEST','Manufacturing')
GO
SELECT *
FROM HumanResources.Department D 
LEFT OUTER JOIN HumanResources.EmployeeDepartmentHistory H
ON D.DepartmentID = H.DepartmentID
GO
SELECT name, I.*
FROM Sales.Store AS S
CROSS APPLY
(SELECT TOP (3) *
FROM Sales.SalesOrderHeader O
WHERE S.CustomerID = O.CustomerID
ORDER BY OrderDate DESC) I
GO
CREATE FUNCTION udfOstatnieZamowienia(@custid AS INT, @n AS INT)
RETURNS TABLE
AS RETURN
SELECT TOP(@n) *
FROM Sales.SalesOrderHeader
WHERE CustomerID = @custid
ORDER BY OrderDate DESC
GO
SELECT name, O.*
FROM Sales.Store AS C
OUTER APPLY udfOstatnieZamowienia(C.CustomerID, 2) AS O
ORDER BY O.Orderdate
GO
CREATE TABLE #SalesOrderTotals 
(CustomerID int NOT NULL, 
OrderMonth int NOT NULL,
SubTotal money NOT NULL )
GO
INSERT #SalesOrderTotals 
SELECT CustomerID, DATEPART(m, OrderDate), 
SubTotal FROM Sales.SalesOrderHeader 
WHERE CustomerID IN (1,2,4,6)
GO
SELECT * 
FROM #SalesOrderTotals 
PIVOT (SUM(SubTotal) 
FOR CustomerID IN 
([1], [2], [3], [4], [5], [6])) 
AS a
GO
SELECT * 
FROM #SalesOrderTotals 
PIVOT (SUM(SubTotal) 
FOR OrderMonth IN 
([1], [2], [3], [4], [5], [6], [7], [8], [9], [10], [11], [12])) 
AS a
GO
CREATE TABLE #MonthlySales
(CustomerID int NOT NULL,
Styczen Money,
Luty Money,
Marzec Money)
GO
INSERT #MonthlySales
SELECT * 
FROM #SalesOrderTotals 
PIVOT (SUM(SubTotal) FOR OrderMonth In (
[1],[2],[3])) As X
GO
SELECT * 
FROM #MonthlySales
UNPIVOT (SubTotal 
FOR Miesiac IN 
(Styczen,Luty,Marzec)) AS I
ORDER BY CustomerID
GO
SELECT *
FROM HumanResources.Department
WHERE DepartmentID < 8 AND GroupName LIKE 'R%' 
GO
SELECT EndDate, ListPrice, COUNT(ProductID)
FROM Production.ProductListPriceHistory
WHERE ProductID < 710
GROUP BY  EndDate, ListPrice
GO
SELECT EndDate, ListPrice, COUNT(ProductID)
FROM Production.ProductListPriceHistory
WHERE ProductID<710
GROUP BY  EndDate, ListPrice,
EndDate WITH ROLLUP
GO
SELECT EndDate, ListPrice, COUNT(ProductID)
FROM Production.ProductListPriceHistory
WHERE ProductID < 710
GROUP BY  EndDate, ListPrice
HAVING EndDate IS NOT NULL AND COUNT(ProductID) > 1
GO
SELECT ProductID, 'Nazwa produktu: ' + UPPER(Name), ListPrice - StandardCost AS Zysk
FROM Production.Product
WHERE ProductSubcategoryID=5
GO
SELECT DISTINCT ProductSubcategoryID, Size
FROM Production.Product
WHERE Size IS NOT NULL
GO
SELECT ProductSubcategoryID,ProductModelID, COUNT(1)
OVER (PARTITION BY ProductSubcategoryID, ProductModelID) LiczbaDuplikatw
FROM Production.Product
WHERE ProductSubcategoryID IS NOT NULL
GO
SELECT ProductSubcategoryID
FROM Production.Product
ORDER BY Name
GO
SELECT DISTINCT ProductSubcategoryID
FROM Production.Product
ORDER BY Name
GO
SELECT TOP 2 Name, ListPrice
FROM Production.Product
ORDER BY ListPrice DESC
GO
SELECT TOP 2 WITH TIES  Name, ListPrice
FROM Production.Product
ORDER BY ListPrice DESC
GO

DBCC FREEPROCCACHE
GO
SELECT *
FROM Person.vStateProvinceCountryRegion
SELECT *
FROM HumanResources.vEmployee
GO
SELECT *
FROM Person.vStateProvinceCountryRegion
GO
SELECT *
FROM HumanResources.vEmployee
GO
SELECT sql.text
FROM sys.dm_exec_query_stats AS qs 
CROSS APPLY sys.dm_exec_sql_text(sql_handle) sql
GO

SET SHOWPLAN_XML ON
GO
SELECT *
FROM HumanResources.Employee, HumanResources.EmployeeAddress
GO
SET SHOWPLAN_XML OFF
GO
SET STATISTICS XML ON
GO
SELECT *
FROM HumanResources.Employee, HumanResources.EmployeeAddress
SELECT *
FROM HumanResources.JobCandidate
GO
SET SHOWPLAN_TEXT ON
GO
SELECT * 
FROM HumanResources.Department
GO
SELECT * 
FROM HumanResources.Department
WHERE DepartmentID<4
GO
SELECT * 
FROM Sales.SalesPerson s JOIN HumanResources.Employee e 
ON e.EmployeeID = s.SalesPersonID
GO
SET SHOWPLAN_TEXT OFF
GO
CREATE TABLE ##T1 (KOL1 INT)
CREATE TABLE ##T2 (KOL1 INT)
GO
SET SHOWPLAN_TEXT ON
GO
SELECT * FROM ##T1 JOIN ##T2
ON ##T1.KOL1 = ##T2.KOL1
GO
SELECT *
FROM Person.StateProvince sp JOIN Person.CountryRegion cr 
ON sp.CountryRegionCode = cr.CountryRegionCode
GO
SELECT ManagerID, COUNT(EmployeeID)
FROM HumanResources.Employee
GROUP BY ManagerID
GO
SELECT CarrierTrackingNumber, AVG(UnitPrice)
FROM Sales.SalesOrderDetail
GROUP BY CarrierTrackingNumber
GO