USE AdventureWorks
/*
BEGIN TRAN
EXEC uspDodajDoKonta '123-456-78-90', 500
EXEC uspOdejmijOdKonta '231-645-87-09', 500
IF @@ERROR=0
COMMIT TRAN
ELSE 
ROLLBACK TRAN
*/
BEGIN TRAN
PRINT @@TRANCOUNT
BEGIN TRAN
PRINT @@TRANCOUNT
BEGIN TRAN
PRINT @@TRANCOUNT
COMMIT TRAN
PRINT @@TRANCOUNT
ROLLBACK TRAN
PRINT @@TRANCOUNT
GO
--DROP TRIGGER HumanResources.trWirtualneTabele
BEGIN TRAN
INSERT INTO HumanResources.Department ([Name], GroupName)
VALUES ('TEST1', 'G1')
SAVE TRAN T
INSERT INTO HumanResources.Department (Name, GroupName)
VALUES ('TEST2', 'G1')
PRINT @@TRANCOUNT
ROLLBACK TRAN T
PRINT @@TRANCOUNT
COMMIT TRAN
SELECT *
FROM HumanResources.Department 
WHERE Name LIKE 'TEST_'
GO

SELECT @@SPID
GO
BEGIN TRAN
UPDATE HumanResources.Department
SET Name = Name
WHERE DepartmentID=2
GO
ROLLBACK
GO

BEGIN TRAN
SELECT *
FROM  HumanResources.Department
WHERE DepartmentID=2

SELECT resource_type, resource_associated_entity_id, request_mode, request_status 
FROM sys.dm_tran_locks
WHERE (resource_associated_entity_id) = OBJECT_ID('HumanResources.Department')
GO

ROLLBACK
GO
BEGIN TRAN
SELECT *
FROM  HumanResources.Department (HOLDLOCK)
WHERE DepartmentID=2

SELECT resource_type, OBJECT_NAME(resource_associated_entity_id), request_mode, request_status 
FROM sys.dm_tran_locks
WHERE (resource_associated_entity_id) = OBJECT_ID('HumanResources.Department')
GO
ROLLBACK
GO

--sesja 1
EXEC sp_getapplock 'ProcLock', 'Exclusive'
EXEC dbo.uspGetManagerEmployees 21


--sesja 2
BEGIN TRAN
EXEC sp_getapplock 'ProcLock', 'Exclusive'
EXEC AdventureWorks.dbo.uspGetManagerEmployees 42


--sesja 1
EXEC sp_releaseapplock 'ProcLock'
GO
ROLLBACK
GO
--sesja 1
BEGIN TRAN
UPDATE HumanResources.Department
SET Name = Name
WHERE DepartmentID<3


--sesja 2
SELECT *
FROM HumanResources.Department


--sesja 3
SELECT resource_type, request_session_id, resource_associated_entity_id, request_mode, request_status 
FROM sys.dm_tran_locks
WHERE resource_database_id = DB_ID('AdventureWorks')
GO
SELECT login_time, host_name, program_name, nt_user_name 
FROM sys.dm_exec_sessions
WHERE session_id IN(52,53)
GO
SELECT text
FROM sys.dm_exec_connections
CROSS APPLY sys.dm_exec_sql_text(most_recent_sql_handle) as T
WHERE session_id IN(52,53)
GO
SELECT status, blocking_session_id, wait_type, wait_time, wait_resource
FROM sys.dm_exec_requests
WHERE session_id IN(52,53)
GO

ROLLBACK
GO

--sesja 1
BEGIN TRAN
UPDATE HumanResources.Department
SET Name = Name
WHERE DepartmentID>5
GO


--sesja 2
BEGIN TRAN
UPDATE Production.Product
SET Name = UPPER(Name)
WHERE ProductID >400
GO


--sesja 1
SELECT *
FROM Production.Product
GO


--sesja 2
SELECT *
FROM HumanResources.Department
GO

DBCC TRACEON (1204, 3605, -1)
GO
--sesja 1
BEGIN TRAN
UPDATE HumanResources.Employee 
SET Title = 'X'
WHERE EmployeeID <3
GO


--sesja 2
SET LOCK_TIMEOUT 1000
GO
SELECT *
FROM HumanResources.Employee
PRINT 'Dalsza cze bloku'
GO
SET LOCK_TIMEOUT -1
GO

--sesja 2
BEGIN TRAN
SELECT *
FROM HumanResources.Department (UPDLOCK)
--dalsza cz transakcji, w ktrej ramach modyfikujemy odczytane dane
GO
ROLLBACK


--sesja 2
SELECT *
FROM HumanResources.Employee 
WHERE EmployeeID >3
GO


--sesja 2
SELECT *
FROM HumanResources.Employee (TABLOCK)
WHERE EmployeeID >3
GO


--sesja 2
SELECT EmployeeID, Title
FROM HumanResources.Employee (READPAST)
WHERE EmployeeID <5
GO


--sesja 2
SELECT EmployeeID,Title
FROM HumanResources.Employee (NOLOCK)
WHERE EmployeeID <5
GO

--sesja 1
ROLLBACK
GO
BEGIN TRAN
UPDATE HumanResources.Department
SET Name = 'XYZ'
WHERE DepartmentID=5
GO

--sesja 2
SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED
SELECT Name
FROM HumanResources.Department
WHERE DepartmentID = 5
GO

--sesja 1
ROLLBACK
GO
SET TRANSACTION ISOLATION LEVEL READ COMMITTED
BEGIN TRAN
SELECT Name
FROM HumanResources.Department
WHERE DepartmentID = 5
GO


--sesja 2
SET TRANSACTION ISOLATION LEVEL READ COMMITTED
UPDATE HumanResources.Department
SET Name = 'XYZ'
WHERE DepartmentID=5
GO


--sesja 1
SELECT Name
FROM HumanResources.Department
WHERE DepartmentID = 5
COMMIT TRAN
GO


--sesja 1
SET TRANSACTION ISOLATION LEVEL REPEATABLE READ
BEGIN TRAN
SELECT COUNT(ProductID)
FROM Production.Product
WHERE ListPrice BETWEEN 100 AND 105
GO


--sesja 2
UPDATE Production.Product
SET ListPrice = 103
WHERE ProductID = 1
GO


--sesja 1
SELECT COUNT(ProductID)
FROM Production.Product
WHERE ListPrice BETWEEN 100 AND 105
COMMIT TRAN



--sesja 1
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE
BEGIN TRAN
SELECT *
FROM Production.Product
WHERE ListPrice BETWEEN 100 AND 105

SELECT DISTINCT resource_type, request_mode
FROM sys.dm_tran_locks
WHERE request_session_id=@@SPID
GO

ROLLBACK
GO
USE MASTER
ALTER DATABASE AdventureWorks
SET READ_COMMITTED_SNAPSHOT ON
WITH ROLLBACK IMMEDIATE
GO
--sesja 1
USE AdventureWorks
BEGIN TRAN
UPDATE HumanResources.Employee 
SET Title = 'X'
WHERE EmployeeID <3
GO


--sesja 2
SELECT EmployeeID, Title
FROM HumanResources.Employee
WHERE EmployeeID <5
GO

USE MASTER
ALTER DATABASE AdventureWorks
SET ALLOW_SNAPSHOT_ISOLATION ON
GO
SELECT snapshot_isolation_state_desc
FROM sys.databases
WHERE name = 'AdventureWorks'
GO
USE AdventureWorks
SET TRANSACTION ISOLATION LEVEL SNAPSHOT 
GO
SELECT * 
FROM HumanResources.Employee
GO


--sesja 1
SET TRANSACTION ISOLATION LEVEL SNAPSHOT
BEGIN TRAN
SELECT ListPrice
FROM Production.Product
WHERE ProductID=514
GO


--sesja 2
BEGIN TRAN
UPDATE Production.Product
SET ListPrice = 200
WHERE ProductID=514
GO


--sesja 1
SELECT ListPrice
FROM Production.Product
WHERE ProductID=514
GO
UPDATE Production.Product
SET ListPrice = 300
WHERE ProductID=514


--sesja 2
COMMIT
